function solverState = removeNucleation(solverState)
% remove nucleation handling to solver structure
%
% THIS FUNCTION IS NO USER FUNCTION.

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2012 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

%% Task
% it removes:
%   * nucleation boundary (second element)
% it retains:
%   * the nucleation pivot as non-active

if solverState.flagNucleation
    
    solverState.flagNucleation = 0;
    
    % remove boundary
    solverState.hcMatrix(:, 2) = [];
    solverState.numberVector(2) = [];
    solverState.indexVector(2) = [];
    solverState.upVector(2) = [];
    
    % retain nucleation pivot as non-active    
    solverState.indexVector(1) = -1;
    
    if solverState.flagDensity
        error('elk:pbeSolver:wrongInput', ['Sorry, nucleation AND tracking ' ...
            ' population densities is not yet properly supported']);
    end
else
    error('elk:solver:generalError', ['nucleation phenomena shall be ' ...
        'removed while it is already removed']);
end

end